﻿using ComputerStoreDataModels.Enums;
using ComputerStoreDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ComputerStoreContracts.ViewModels
{
    public class OrderViewModel : IOrderModel
    {
        [DisplayName("Order ID")]
        public int ID { get; set; }
        [DisplayName("Price")]
        public double Price { get; set; }
        [DisplayName("Status")]
        public OrderStatus Status { get; set; }
        [DisplayName("Creation date")]
        public DateTime DateCreate { get; set; }
        [DisplayName("Implementation date")]
        public DateTime? DateImplement { get; set; }

        public int SellerID { get; set; }
        [DisplayName("SellerUsername")]
        public string? SellerUsername { get; set; } = string.Empty;

        public List<IConsignmentModel>? OrderConsignments { get; set; } = new();
        public List<IRequestModel>? OrderRequests { get; set; } = new();
    }
}
