﻿using ComputerStoreContracts.SearchModels;
using ComputerStoreContracts.StorageContracts;
using ComputerStoreContracts.ViewModels;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ComputerStoreDatabaseImplement.Implements
{
    public class RequestComponentStorage : IRequestComponentStorage
    {
        public List<RequestComponentViewModel> GetFilteredList(RequestSearchModel model)
        {
            using var context = new ComputerStoreDatabase();
            var list = new List<RequestComponentViewModel>();
            foreach (var pc in context.RequestComponents.Include(x => x.Component).Include(x => x.Request).Where(x => x.PCID == null && x.RequestID == model.ID))
            {
                list.Add(new RequestComponentViewModel
                {
                    RequestID = pc.RequestID,
                    ComponentID = pc.ComponentID,
                    ComponentName = pc.Component.Name,
                    ComponentCount = pc.Count,
                });
            }
            return list;
        }

        public List<RequestComponentViewModel> GetFullList()
        {
            using var context = new ComputerStoreDatabase();
            
            var list = new List<RequestComponentViewModel>();

            foreach(var pc in context.RequestComponents.Include(x => x.Component).Include(x => x.Request).Where(x => x.PCID == null))
            {
                list.Add(new RequestComponentViewModel {
                    RequestID = pc.RequestID, 
                    ComponentID = pc.ComponentID, 
                    ComponentName = pc.Component.Name, 
                    ComponentCount = pc.Count,
                });
            }
            return list;
        }
    }
}
