﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace ComputerStoreDatabaseImplement.Migrations
{
    /// <inheritdoc />
    public partial class RelationFixes : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Orders_Sellers_OrderID",
                table: "Orders");

            migrationBuilder.DropForeignKey(
                name: "FK_RequestComponents_PCs_PCID",
                table: "RequestComponents");

            migrationBuilder.DropIndex(
                name: "IX_Orders_OrderID",
                table: "Orders");

            migrationBuilder.DropColumn(
                name: "OrderID",
                table: "Orders");

            migrationBuilder.AlterColumn<int>(
                name: "PCID",
                table: "RequestComponents",
                type: "int",
                nullable: true,
                oldClrType: typeof(int),
                oldType: "int");

            migrationBuilder.CreateIndex(
                name: "IX_Orders_SellerID",
                table: "Orders",
                column: "SellerID");

            migrationBuilder.AddForeignKey(
                name: "FK_Orders_Sellers_SellerID",
                table: "Orders",
                column: "SellerID",
                principalTable: "Sellers",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_RequestComponents_PCs_PCID",
                table: "RequestComponents",
                column: "PCID",
                principalTable: "PCs",
                principalColumn: "ID");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Orders_Sellers_SellerID",
                table: "Orders");

            migrationBuilder.DropForeignKey(
                name: "FK_RequestComponents_PCs_PCID",
                table: "RequestComponents");

            migrationBuilder.DropIndex(
                name: "IX_Orders_SellerID",
                table: "Orders");

            migrationBuilder.AlterColumn<int>(
                name: "PCID",
                table: "RequestComponents",
                type: "int",
                nullable: false,
                defaultValue: 0,
                oldClrType: typeof(int),
                oldType: "int",
                oldNullable: true);

            migrationBuilder.AddColumn<int>(
                name: "OrderID",
                table: "Orders",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateIndex(
                name: "IX_Orders_OrderID",
                table: "Orders",
                column: "OrderID");

            migrationBuilder.AddForeignKey(
                name: "FK_Orders_Sellers_OrderID",
                table: "Orders",
                column: "OrderID",
                principalTable: "Sellers",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_RequestComponents_PCs_PCID",
                table: "RequestComponents",
                column: "PCID",
                principalTable: "PCs",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
