﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace ComputerStoreDatabaseImplement.Migrations
{
    /// <inheritdoc />
    public partial class RelationsFixesV10 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Consignments_Orders_OrderID",
                table: "Consignments");

            migrationBuilder.AlterColumn<int>(
                name: "OrderID",
                table: "Consignments",
                type: "int",
                nullable: true,
                oldClrType: typeof(int),
                oldType: "int");

            migrationBuilder.AddForeignKey(
                name: "FK_Consignments_Orders_OrderID",
                table: "Consignments",
                column: "OrderID",
                principalTable: "Orders",
                principalColumn: "ID");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Consignments_Orders_OrderID",
                table: "Consignments");

            migrationBuilder.AlterColumn<int>(
                name: "OrderID",
                table: "Consignments",
                type: "int",
                nullable: false,
                defaultValue: 0,
                oldClrType: typeof(int),
                oldType: "int",
                oldNullable: true);

            migrationBuilder.AddForeignKey(
                name: "FK_Consignments_Orders_OrderID",
                table: "Consignments",
                column: "OrderID",
                principalTable: "Orders",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
